function [T] = Gen_Var_T(Detection,m,n,y,g,SNR)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% If you want to implement a new technique do it in the reserved place 
%"6-Customized User Technique" in the code  below.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Description of the input parameters:
% m: number of Cognitive radios
% n: number of samples colected by each CR
% y: Array of samples mxn
% g: Gain used to simulate the LNA and AGC
% SNR: Signal to Noise Ratio
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Generate random decision variable T based on the technique chosen by the user.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

	%Covariance Matrix
	W = y * ctranspose(y)/n;
	%Eingvalue of W
    lambda = sort(eig(W),'descend');


	switch Detection
	
		%%%%%%%%%%%%%%%%
		%%%%%% ED %%%%%%
		%%%%%%%%%%%%%%%%
		case 1

			soma = 0;
			Tnum = 0;
			Tden = 0;         
			%Calculating the numerator of T
			Tnum = 1/(m*n) * sum(sum((abs(y)).^2));
			%Calculating the denominator of T
			for i = 1 : m 
				soma = soma  + g(i).^2 .* (10^(SNR/10)).^-1;
			end
			Tden = 1/m * soma;       
			T = Tnum / Tden;
									
		%%%%%%%%%%%%%%%%%%%%%%%%
		%%%%%% ERD - MMED %%%%%%
		%%%%%%%%%%%%%%%%%%%%%%%%
		case 2
		
			%Maximun/Minimum
			T = lambda(1)/lambda(m);
						
		%%%%%%%%%%%%%%%%%%
		%%%%%% BCED %%%%%%
		%%%%%%%%%%%%%%%%%%
		case 3
		
			T = lambda(1)/ (10^(SNR/10))^-1;
			
		%%%%%%%%%%%%%%%%%%
		%%%%%% RLRT %%%%%%
		%%%%%%%%%%%%%%%%%%		
		case 4
		
			soma = 0;
			Tden = 0;
			%Calculating the denominator of T
			for i = 1 : m 
				soma = soma  + g(i).^2 * (10^(SNR/10))^-1;
			end
			Tden = 1/m * soma;	
			T = lambda(1)/ Tden;	
			
		%%%%%%%%%%%%%%%%%%
		%%%%%% GLRT %%%%%%
		%%%%%%%%%%%%%%%%%%		
		case 5		
			T = lambda(1) / (sum(diag(W))/m);
            
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%%%%%% Customized User Technique %%%%%%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%			
		case 6	
            
			%T = ?;
            
            
		otherwise
			null;
	end

	


		
