function [Wwf] = Gen_Whitening_Filter(n,L)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%% Gera Matriz do Filtro branqueador
%%%%%%% Entradas : (n,L)  Retorna: Wwf_nxn
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Resposta impulsiva %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%
h(1:L)= 1;
Index_max = 0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Calcula convolucao e normaliza %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
convol = real(conv(h,h)/max(conv(h,h)));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Acha o maximo da correlacao %%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i = 1 : length(convol)
    if convol(i) == 1 
        Index_max = i;
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Pega os valores do pico at o fim da conv, dp zera restante at n %%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Corr = convol(Index_max:(Index_max + L - 1));
Corr(n)=0;


q = Corr;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% Qij, conforme art Platafor Simulacao Sensoriamento %%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i = 1 : n
    for j = 1:n
        Q(i,j)= q(abs(i-j)+1);
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Decomposicao singular de Q %%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[u s v] = svd(Q);
Q1 = [u;s];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Matriz ortogonal a Q = U.sum.K'%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
C = chol(Q,'lower');
U = Q1(1:n,1:n);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%% Filtro Branqueador nxn %%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Wwf = U*inv(C);
disp('Whitening Filter Ok');
