function [Pd,Pfa,T_H0,T_H1]  =  calc_Pd_Pfa_prat(m,n,p,Nevents,Nb,Ns,K,Pin,Pcr,A,B,Beta,Op_IN_Tipe,Nq,D,Fod,L,h,PAPRs,Detection,Stx,SNR,limiar,Wwf,Fma,Vec_Simbol)
%-----------------------------------------------------------------------%
% Funo que calcula a Pd e Pfa no Modelo Prtico
%
%-----------------------------------------------------------------------%

cont_d        = 0;
cont_fa       = 0;
cont_total_tx  = 0;
cont_total_ntx = 0;
H = zeros(m,p);
X = zeros(p,n);
V = zeros(m,n);
Y = zeros(m,n);
T_H0 = zeros(1,Nevents);
T_H1 = zeros(1,Nevents);

for ind = 1 : Nevents

	%%%%%%%%%%%%%%%%%%%%%%%
	%%% Rido impulsivo %%%
	%%%%%%%%%%%%%%%%%%%%%%%	
	if K > 0
		[VI] = Gen_Impulsive_Noise(m,n,Nb,Ns,K,Pin,Pcr,A,B,Beta,Op_IN_Tipe,SNR);
	else	
		VI = zeros(m,n);		
    end
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%% Preenche a matriz de canal %%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    [H] = Gen_Channel_H(m,p);	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%% Preenche a matriz de transmisso %%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
	[X] = Gen_Tx_Signal_X(p,n,Stx,Vec_Simbol);
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%% Preenche a matriz de ruido %%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    V = (sqrt(1/(2*10^(SNR/10)))).* randn(m,n) + j * (sqrt(1/(2*10^(SNR/10)))).* randn(m,n); 


    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%% Matriz Recebida de amostras com uma aleatoriedade inserida hora transmite hora nao transmite%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    I_tx = randi([0 1]);  
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%% Leva em conta probabilidade de ocorrencia do ruido impulsivo %%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
    I_ri = binornd(1,Pin);
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%% Modelo prtico %%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	ZpadX(p,L) = 0;
	Zpad(m,L)= 0;
	
	%%%%%%%%%%%%%%%%%
	%%% Filtra X %%%%
	%%%%%%%%%%%%%%%%%
	Xma_aux = ([X ZpadX] * transpose(Fma));
	Xma = Xma_aux( 1 : p , L:(n+L-1));
	Px = 1 / (p*n) * sum(sum((abs(Xma)).^2));
	X = Xma /sqrt(Px);

    
	
	%%%%%%%%%%%%%%%%%
	%%% Filtra V %%%%
	%%%%%%%%%%%%%%%%%	
	Vma_aux = ([V Zpad] * transpose(Fma));
	Vma = Vma_aux( 1 : m , L:(n+L-1));
	Pv = 1 / (m*n) * sum(sum((abs(Vma)).^2));
	V = Vma /sqrt(Pv)*sqrt(1/(10.^(SNR/10)));
    
	%%%%%%%%%%%%%%%%%
	%%% Filtra VI %%%
	%%%%%%%%%%%%%%%%%	
	Vmai_aux = ([VI Zpad] * transpose(Fma));
	Vmai = Vmai_aux( 1 : m , L:(n+L-1));
	Pvi = 1 / (m*n) * sum(sum((abs(Vmai)).^2));
	
    if K == 0
        VI = zeros(m,n);
    else
        VI = Vmai /sqrt(Pvi)*sqrt(K/(10.^(SNR/10)));	
    end
    Y = I_tx * H * X + V + I_ri .* VI;
 
	
	for k = 1: m
		
		Yt = Y';
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%%% Filtra cada linha da Matriz de recepao %%%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		Ywf = Wwf * Yt(:,k);
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%%% Calcula energia total das amostras filtradas
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		Y_wf_aux = ctranspose(Ywf) * Ywf;
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%%%%%%%% Calcula g(i) para cada rdio cognitivo %%%%%%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		g(k) = sqrt(2) * D/(6/Fod) * (1 / sqrt(1/n * Y_wf_aux(1,:)));
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%%%%% Multiplica as amostras pelo g(i) %%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		yin = g(k) * Ywf;
		
		PAPR = max(abs(yin)) / ( 1/n * sum((abs(yin)).^2)); %%% mexi aqui
		if PAPR > PAPRs
			yin = sqrt(PAPR) * yin;
		else
			yin = yin;
		
		end
		
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%%% Quantizador Real e imaginrio %%%%%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		ReY = real(yin);
		for i = 1 : n
			
			if abs(ReY(i)) < (D/2)
				ReYc(i) = ReY(i);
			else
				ReYc(i) = sign(ReY(i)) * D/2;
			end
		end
		
		ImY = imag(yin);
		for i = 1 : n
			if abs(ImY(i)) < (D/2)
				ImYc(i) = ImY(i);
			else
				ImYc(i) = sign(ImY(i)) * D/2;
			end
		end
		
		reY(:,k)= quantizador(ReYc,Nq);
		imY(:,k)= quantizador(ImYc,Nq);
	end % Fim do for k
	
	y = reY' + 1i* imY';
	
	
	
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Escolhe qual tipo de mtodo de deteco %
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
	[T] = Gen_Var_T(Detection,m,n,y,g,SNR);
    

    

	% Se T > limiar e transmitiu conta detecao
	cont_d = cont_d + (abs(T) > limiar)*I_tx ;
	% Se T > limiar e nao transmitiu conta FA
	cont_fa = cont_fa + (abs(T) > limiar)* not(I_tx);
	
	% Nmerde vezes que transmitiu dado
	cont_total_tx  = cont_total_tx + I_tx;
	% Nmero de vezes que nao transmitiu dado
	cont_total_ntx = cont_total_ntx + not(I_tx);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% Para Gerao das pdfs H0 e H1 %%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	if I_tx == 1
	
		T_H1(cont_total_tx) = abs(T);
	
	else
	
		T_H0(cont_total_ntx) = abs(T);
	
	end;



end; % Fim do While

Pd = cont_d / cont_total_tx; 
Pfa = cont_fa / cont_total_ntx;

T_H0 = T_H0;
T_H1 = T_H1;

