function [Pd,Pfa,T_H0,T_H1] = calc_Pd_Pfa_proposto(m,n,p,Nevents,Detection,Stx,SNR,limiar,Vec_Simbol)
%-----------------------------------------------------------------------%
% Funo que calcula a Pd e Pfa 
%
%-----------------------------------------------------------------------%

cont_d        = 0;
cont_fa       = 0;
cont_total_tx  = 0;
cont_total_ntx = 0;
H = zeros(m,p);
X = zeros(p,n);
V = zeros(m,n);
Y = zeros(m,n);
T_H0 = zeros(1,Nevents);
T_H1 = zeros(1,Nevents);
Aux_1 = zeros(n,m);

for ind = 1 : Nevents

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%% Preenche a matriz de canal %%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    [H] = Gen_Channel_H(m,p);	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%% Preenche a matriz de transmisso %%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
	[X] = Gen_Tx_Signal_X(p,n,Stx,Vec_Simbol);
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%% Preenche a matriz de ruido %%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    V = (sqrt(1/(2*10^(SNR/10)))).* randn(m,n) + j * (sqrt(1/(2*10^(SNR/10)))).* randn(m,n); 
	
    % ------------------------------------------------------------------------------------------------%
    % - Matriz Recebida de amostras com uma aleatoriedade inserida hora transmite hora nao transmite -%
	% ------------------------------------------------------------------------------------------------%
    I_tx = randi([0 1]);   
    Y = I_tx * H * X + V;
    
    % -------------------------------------------------------------------- %
    % - Analisa as amostras de cada radio cognitivo criando a diagonal g - %
	% ---------------------------------------------------------------------%
    for x = 1 : m
        
        Aux_1 = Y';
        y = Aux_1(:,x);
        
        g(x) = 1 / (max(abs(real(y))) + max(abs(imag(y))));
              
    end
    
    G = diag(g);
    y = G * Y;
	
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Escolhe qual tipo de mtodo de deteco %
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
	[T] = Gen_Var_T(Detection,m,n,y,g,SNR);
    
	% Se T > limiar e transmitiu conta detecao
	cont_d = cont_d + (abs(T) > limiar)*I_tx ;
	% Se T > limiar e nao transmitiu conta FA
	cont_fa = cont_fa + (abs(T) > limiar)* not(I_tx);
	
	% Nmerde vezes que transmitiu dado
	cont_total_tx  = cont_total_tx + I_tx;
	% Nmero de vezes que nao transmitiu dado
	cont_total_ntx = cont_total_ntx + not(I_tx);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% Para Gerao das pdfs H0 e H1 %%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	if I_tx == 1
	
		T_H1(cont_total_tx) = abs(T);
	
	else
	
		T_H0(cont_total_ntx) = abs(T);
	
	end;





end; % Fim do While

Pd = cont_d / cont_total_tx; 
Pfa = cont_fa / cont_total_ntx;

T_H0 = T_H0;
T_H1 = T_H1;

